APP = {
    configuration: {
        login_url: "http://localhost/everest/index.html?token=72ea52326339f45065bb40458986a56c", // ALTERAR AQUI
        pushPublicKey: "BM1aWwz5kDKthYBjSuKN8wI2S3umNDUiGyZbU2A3eZDelr0Hbh8QkeWYtQLxgMdiwPaEO7HLJCarMQyAMmjb-J8",// https://web-push-codelab.glitch.me/
        database: {
            name: "app",
            version: 1,
            schema: {
                config: 'id',
            }
        },

    },
    VERSION: 2,
    USER: null,
    TOKEN: "",
    db: null,
    ONLINE: false,
    login: (token) => {

    },
    init: (forceOffline) => {
        document.body.dataset.online = navigator.onLine;
        APP.ONLINE = navigator.onLine;
        APP.TOKEN = localStorage.token;
        APP.db = new Dexie(APP.configuration.database.name);
        APP.db.version(APP.configuration.database.version).stores(APP.configuration.database.schema);

        let u = new URLSearchParams(window.location.search);
        if (u.get('token') && u.get('token') != "") {
            localStorage.token = u.get('token');
            APP.TOKEN = u.get('token');
        }
        if ((APP.ONLINE && !forceOffline) && !APP.TOKEN) {
            window.location.href = APP.configuration.login_url;
        } else if ((APP.ONLINE && !forceOffline)) {
            APP.login(APP.TOKEN);
        } else {
            APP.main();
        }
    },
    main: (include, box) => {
        if (!include)
            include = "home";
        if (!box)
            box = document.querySelector("main");
        if (box)
            fetch("assets/includes/" + include + ".html").then(x => x.text())
                .then(y => {
                    box.innerHTML = y;
                    if (APP.includes[include])
                        APP.includes[include](box);
                });
    },
    includes: {
        home: (element) => {
            console.log(element);

        },
    }
};
window.addEventListener('load', (event) => {
    APP.init();
});
window.ononline = () => {
    document.body.dataset.online = true;
    APP.ONLINE = true;
}
window.onoffline = () => {
    document.body.dataset.online = false;
    APP.ONLINE = false;
}

if ('serviceWorker' in navigator) {
    navigator.serviceWorker.register('sw.js')
        .then((swRegistration) => {
            console.log('Service Worker is registered', swRegistration);
            APP.swRegistration = swRegistration;

            subscribeUser();
            swRegistration.pushManager.getSubscription()
                .then(function (subscription) {
                    isSubscribed = !(subscription === null);
                    if (isSubscribed) {
                        console.log('User IS subscribed.');
                    } else {
                        console.log('User is NOT subscribed.');
                    }
                });
        })
        .catch(err => console.error('error registering sw', err));

    navigator.serviceWorker.addEventListener('message', event => {
        // event.data will contain {alreadyCached, allUrls}.
        console.log(event.data);
    });
}
function urlB64ToUint8Array(base64String) {
    const padding = '='.repeat((4 - base64String.length % 4) % 4);
    const base64 = (base64String + padding)
        .replace(/\-/g, '+')
        .replace(/_/g, '/');

    const rawData = window.atob(base64);
    const outputArray = new Uint8Array(rawData.length);

    for (let i = 0; i < rawData.length; ++i) {
        outputArray[i] = rawData.charCodeAt(i);
    }
    return outputArray;
}
function subscribeUser() {
    const applicationServerKey = urlB64ToUint8Array(APP.configuration.pushPublicKey);
    APP.swRegistration.pushManager.subscribe({
        userVisibleOnly: true,
        applicationServerKey: applicationServerKey
    })
        .then(function (subscription) {
            APP.subscription = subscription;
            isSubscribed = true;
        })
        .catch(function (error) {
            console.error('Failed to subscribe the user: ', error);
        });
}
async function periodicSync() {
    const registration = await navigator.serviceWorker.ready;
    if ('periodicSync' in registration) {
        try {
            const status = await navigator.permissions.query({
                name: 'periodic-background-sync',
            });
            //console.log(status);
            await registration.periodicSync.register('content-sync', {
                // An interval of one day.
                minInterval: 10 * 1000//24 * 60 * 60 * 1000,
            });
        } catch (error) {
            // Periodic background sync cannot be used.
        }
    }
}
periodicSync();