importScripts('/assets/js/dexie.min.js');

var cacheVer = 'wa-0.93c';

var APPDB_schema = {
    clientes: '++id,status,nome,tipo',
    usuarios: '++id,usuario,email,nome,status',
    tipos: '++id,nome,setor,status',
    tarefas: '++id,usuario,tipo,status,setor,nome,datac,datae,datao,dataf,datau',
    configuration: 'chave',
    marcadores: '++id,titulo,setores',
    status: '++id,nome,cor,tipo,nivel,setor',
    setores: '++id,nome,cor',
}

var userId = null;
var token = null;
var urlApi = null;
var database = null;
var db = null;
var registrador = {};
var APPDB = {};
//============================
// https://web.dev/fast-playback-with-preload/
//find . -name '*'> lista
let FilesForCache = [
    "/index.html",
    '/assets/js/dexie.min.js',
    '/novo_relatorio.html'
];

self.addEventListener('install', async event => {
    event.waitUntil((async () => {
        const alreadyCached = [];
        const clients = await self.clients.matchAll({
            includeUncontrolled: true,
        });
        const cache = await caches.open(cacheVer);
        for (const url of FilesForCache) {
            await cache.add(url);
            alreadyCached.push(url);
            for (const client of clients) {
                client.postMessage({
                    type: "update",
                    cached: alreadyCached,
                    forCache: FilesForCache
                });
            }
        }
    })());
});

self.addEventListener('activate', (event) => {
    const currentCaches = [FilesForCache];
    event.waitUntil(
        caches.keys()
            .then(cacheNames => { return cacheNames.filter(cacheName => !currentCaches.includes(cacheName)); })
            .then(cachesToDelete => { return Promise.all(cachesToDelete.map(cacheToDelete => { return caches.delete(cacheToDelete); })); })
            .then(() => self.clients.claim())
    )
});

self.addEventListener('fetch', function (event) {
    event.respondWith(caches.match(event.request).then(function (response) {
        if (response !== undefined) {
            return response;
        } else {
            return fetch(event.request).then(function (response) {
                let responseClone = response.clone();

                caches.open(cacheVer).then(function (cache) {
                    if (false)
                        if (!event.request.url.includes("sw.js") && !event.request.url.includes("manifest.json") && event.request.url.includes("https://everestcom.weeke.app/")) {
                            console.log("Cached " + cacheVer, event.request.url);
                            cache.put(event.request, responseClone);
                        } else {
                        }
                });
                return response;
            });
        }
    }));
});

self.addEventListener('push', function (e) {
    console.log(e);

    let data = e.data.json();
    console.log(data)
    if (data.action && data.action.length) {
        if (data.action.includes('syncContent')) {
            e.waitUntil(syncContent());
        }
    }
    if (false) {
        var options = {
            body: 'This notification was generated from a push!',
            icon: 'assets/favicons/android-chrome-144x144.png',
            vibrate: [100, 50, 100],
            data: {
                dateOfArrival: Date.now(),
                primaryKey: '2'
            },
            actions: [{
                action: 'explore',
                title: 'Explore this new world',
                icon: 'images/checkmark.png'
            },
            {
                action: 'close',
                title: 'Close',
                icon: 'images/xmark.png'
            },
            ]
        };
        console.log(options);
        e.waitUntil(
            self.registration.showNotification('Hello world!', options)
        );
    }
});
serverFetch = async (API, onsuccess, post) => {
    var isObj = function (a) {
        if ((!!a) && (a.constructor === Object)) {
            return true;
        }
        return false;
    };
    var _st = function (z, g) {
        return "" + (g != "" ? "[" : "") + z + (g != "" ? "]" : "");
    };
    var fromObject = function (params, skipobjects, prefix) {
        if (skipobjects === void 0) {
            skipobjects = false;
        }
        if (prefix === void 0) {
            prefix = "";
        }
        var result = "";
        if (typeof (params) != "object") {
            return prefix + "=" + encodeURIComponent(params) + "&";
        }
        for (var param in params) {
            var c = "" + prefix + _st(param, prefix);
            if (isObj(params[param]) && !skipobjects) {
                result += fromObject(params[param], false, "" + c);
            } else if (Array.isArray(params[param]) && !skipobjects) {
                params[param].forEach(function (item, ind) {
                    result += fromObject(item, false, c + "[" + ind + "]");
                });
            } else {
                result += c + "=" + encodeURIComponent(params[param]) + "&";
            }
        }
        return result;
    };
    let data = null;
    let method = "GET";
    if (post) {
        method = "POST";
        data = fromObject(post)
    }
    if (!onsuccess)
        onsuccess = function (w) {
            console.log(w);
        }
    fetch(urlApi + "" + database + "/lite/" + API + "&ajax", {
        headers: {
            'Content-Type': 'application/json',
            'usuario': userId,
            'token': token,
            'Content-Type': "application/x-www-form-urlencoded; charset=UTF-8"
        },
        method: method,
        body: data
    }).then(r => r.json()).then(r => {
        onsuccess(r);
    })
};
syncContent = async function () {
    if (!db || !userId) {
        db = new Dexie('config');
        db.version(1).stores({ global: '++key,value' });
        userId = (await db.global.where('key').equals('user').first()).value;
        token = (await db.global.where('key').equals('token').first()).value;
        urlApi = (await db.global.where('key').equals('url').first()).value;
        database = (await db.global.where('key').equals('database').first()).value;
    }
    serverFetch('json&usuario_info&base_info&ajax', function (e) {
        console.warn(e);
        serverFetch('registrador&ajax&TAREFA&CLIENTE&USUARIO&SETOR&GRUPO_CLIENTE&SERVICO&STATUS&TIPO_DE_TAREFA&MARCADOR', async function (r) {
            await db.global.put(
                {
                    "key": 'registrador',
                    "value": r,
                    'date': new Date()
                }
            );
            if (!registrador.TAREFA || registrador.TAREFA != r.TAREFA && false)
                serverFetch('json&tarefas_listar', async function (t) {
                    //==
                    APPDB = new Dexie(database);
                    APPDB.version(1).stores(APPDB_schema);
                    registrador.TAREFA = t.TAREFA;
                    await APPDB.tarefas.bulkPut(t.tarefas_listar);
                    console.log('tarefas', t.tarefas_listar);
                    //==
                }, { config: { limite: 100, registrador: (registrador.TAREFA || "") } });
        });

    });
}
self.addEventListener('periodicsync', (event) => {
    console.log(event);
    if (event.tag === 'content-sync') {
        // See the "Think before you sync" section for
        // checks you could perform before syncing.
        event.waitUntil(syncContent());
    }
    // Other logic for different tags as needed.
});